define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	var Model = function() {
		this.callParent();
		this._prevBtn = null;// 上一题按钮（dom节点）
		this._nextBtn = null;// 下一题按钮（dom节点）

		this._indexI = 0;// 当前题目索引，从0开始
		this._len;// 题目数量
		this._isBtnClick = false;// 是否是按钮点击上下切换题目事件
		this._questionDatas = null;// 试题数据
		this._testCost = null;// 考试时间
		this._answerCount = 0;// 已回答试题数量
	};

	/**
	 * 
	 * @author shaoyi
	 * @date 2016-12-15 上午11:05:05
	 * 
	 * @email 3328175381@qq.com
	 * @copyright 作者原创，转载务必注明出处，谢谢！
	 * 
	 * @project 英雄三国APP
	 * @description 考试页面
	 * 
	 */

	// answerList过滤条件
	// $row.val("questionId")==$model.comp('questionData').val("questionId")
	/**
	 * model 参数接收事件
	 * 
	 * @param event
	 */
	Model.prototype.modelParamsReceive = function(event) {

		this._prevBtn = $(this.getElementByXid("prevBtn"));// 上一题按钮
		this._nextBtn = $(this.getElementByXid("nextBtn"));// 下一题按钮

		// 接收考试列表页面传入的参数
		var passdata = event.params.data;

		var testName = passdata.testName;// 考试名称
		var testStaffId = passdata.testStaffId;// 考试人员标识
		var testName = passdata.testName;// 考试名称
		var testScore = passdata.testScore;// 总分
		var testCost = passdata.testCost;// 答题时间(分钟)
		var passScore = passdata.passScore;// 及格分数
		var testQuestionCount = passdata.testQuestionCount;// 题目数量
		var singleSelCount = passdata.singleSelCount;// 单选题数量
		var singleSelTotalScore = passdata.singleSelTotalScore;// 单选题总分数
		var judgeCount = passdata.judgeCount;// 判断题数量
		var judgeTotalScore = passdata.judgeTotalScore;// 判断题总分数
		var multiSelCount = passdata.multiSelCount;// 多选题数量
		var multiSelTotalScore = passdata.multiSelTotalScore;// 多选题总分数

		var testPaperDatas = passdata.testPaperDatas;// 试卷内容

		var detailDatas = passdata;

		var testDetailData = this.comp("testDetailData");
		testDetailData.loadData([ detailDatas ]);
		testDetailData.first();// 指向第一条数据
		this.comp("testDetailPopOver").show();

		// 考试详情提示框，显示字段bind-html代码
		// $model.testDetailData.val("testName")?$model.testDetailData.val("testName"):null
		// $model.testDetailData.val("testCost")?"考试时长："+$model.testDetailData.val("testCost")+"分钟":"考试时长：null分钟"
		// $model.testDetailData.val("testScore")?"考试总分："+$model.testDetailData.val("testScore")+"分":"考试总分：null分"
		// $model.testDetailData.val("passScore")?"及格分数："+$model.testDetailData.val("passScore")+"分":"及格分数：null分"
		// $model.testDetailData.val("testQuestionCount")?"总题数："+$model.testDetailData.val("testQuestionCount")+"题":"总题数：null题"
		// "单选题："+$model.testDetailData.val("singelSelCount")+"题"+"("+$model.testDetailData.val("singelSelTotalScore")+"分)"
		// "多选题："+$model.testDetailData.val("multiSelCount")+"题"+"("+$model.testDetailData.val("multiSelTotalScore")+"分)"
		// "判断题："+$model.testDetailData.val("judgeCount")+"题"+"("+$model.testDetailData.val("judgeTotalScore")+"分)"

		// 处理考试时间
		if (testCost && testCost > 9) {
			this._testCost = testCost + ":00";
		} else if (testCost && testCost < 10) {
			this._testCost = "0" + testCost + ":00";
		} else {
			this._testCost = "00:00";
		}
		// set考试时间
		this.comp("timeBtn").set({
			"label" : this._testCost
		});

		// set考试名称
		this.comp("tNameOut").set({
			value : testName
		});

		// 将试题set到data组件中
		this.setTestPaperDatas(testPaperDatas);
	};

	/**
	 * 考试详情取消按钮
	 * 
	 * @param event
	 */
	Model.prototype.detailCancelBtnClick = function(event) {

		this.comp("testDetailPopOver").hide();
		this.owner.close();
	};

	/**
	 * 考试详情确认按钮 参加考试事件
	 * 
	 * @param event
	 */
	Model.prototype.detailConfirmBtnClick = function(event) {
		var self = this;

		// 开启时间倒计时
		this.countdownTimer(this._testCost);
		this.comp("testDetailPopOver").hide();

	};

	/**
	 * 给上下切换索引按钮 切换disabled Class
	 * 
	 */
	Model.prototype.toggleDisabledClass = function() {

		var questionData = this.comp("questionData");
		// 获得data当前行，即当前显示的题目数据
		var questionData_row = questionData.getCurrentRow();

		// 当前显示的题目在试题data数据中的索引下标
		var questionDatas_index = questionData.getRowIndex(questionData_row);

		if (this._len > 1) {
			// 判断当题目数量大于1
			if (questionDatas_index === 0) {
				// 当前题在试题data中为第一题，禁用上一题切换按钮
				this._prevBtn.addClass("disabled");
				this._nextBtn.removeClass("disabled");
			} else if (questionDatas_index === this._len - 1) {
				// 当前题在试题data中为最后一题，禁用下一题切换按钮
				this._prevBtn.removeClass("disabled");
				this._nextBtn.addClass("disabled");
			} else {
				// 当题目在试题data数据中间位置的时候，开放按钮功能，可以上下切换
				this._prevBtn.removeClass("disabled");
				this._nextBtn.removeClass("disabled");
			}
		} else {
			// 当题目数量<=1时，禁用上下切换按钮
			this._prevBtn.addClass("disabled");
			this._nextBtn.addClass("disabled");
		}

		// 设置考试进度值（1/20）
		this.setProgressHtml(parseInt(questionDatas_index + 1));
	};

	/**
	 * 设置考试进度值（1/20）
	 * 
	 * @param progressCount(当前进度)
	 */
	Model.prototype.setProgressHtml = function(progressCount) {

		var progressOut = this.getElementByXid("progressOut");
		var html = "";

		if (progressCount && this._len) {
			html = '<font color="#ff4141">' + progressCount + '</font>' + '/' + this._len;
		} else {
			html = '<font color="#ff4141">0/0</font>';
		}
		$(progressOut).html(html);

	};

	/**
	 * 将试题set到data组件中
	 * 
	 * @param testPaperDatas
	 */
	Model.prototype.setTestPaperDatas = function(testPaperDatas) {
		var self = this;

		var examQuestionDatas = testPaperDatas.examQuestion;

		var questionData = this.comp("questionData");
		questionData.loadData(examQuestionDatas);
		questionData.first();// 初始显示第一道题
		this._len = questionData.getCount();// 题目数量
		this._questionDatas = examQuestionDatas.rows;

		this.comp("sheetData").loadData(examQuestionDatas);

		// 将数据加入 题型 data
		var questionClassData = this.comp("questionClassData");
		questionClassData.loadData(examQuestionDatas, true, null, null, true);// 覆盖id插入到data组件中

		var examQuestionAnswerDatas = testPaperDatas.examQuestionAnswer;
		var answerData = this.comp("answerData");
		answerData.loadData(examQuestionAnswerDatas);

		this.toggleDisabledClass();
		this.initContentData();

	};

	/**
	 * 初始化content数据
	 * 
	 */
	Model.prototype.initContentData = function() {
		var self = this;
		var questionData = this.comp("questionData");
		var _content = $(this.getElementByXid("parentContents")).children("div");
		var parentContents = this.comp("parentContents");

		if (this._len == 2 || this._len == 1) {

			for (var i = 0; i < this._len; i++) {
				$(_content[i]).find("span.question-caption").html(this.getQuestionCaption(this._questionDatas[i].questionClass, this._questionDatas[i].questionContent));
				var listXid = $(_content[i]).find("div.x-list").attr("xid");
				var list = self.comp(listXid);
				list.set("filter", "$row.val('questionId')==" + this._questionDatas[i].questionId + "");
				// 刷新
				list.refresh();
			}
			// 如果只有1或者2道题，则删除多余的content
			parentContents.remove(2);

			if (this._len == 1) {
				parentContents.remove(1);
			}

		} else if (this._len > 2) {

			for (var i = 0; i < 3; i++) {

				$(_content[i]).find("span.question-caption").html(this.getQuestionCaption(this._questionDatas[i].questionClass, this._questionDatas[i].questionContent));
				var listXid = $(_content[i]).find("div.x-list").attr("xid");
				var list = self.comp(listXid);
				list.set("filter", "$row.val('questionId')==" + this._questionDatas[i].questionId + "");
				// 刷新
				list.refresh();

			}

		} else {
			// 没有试题数据
		}

	};

	/**
	 * 获得题目标题 (题型)题目
	 * 
	 * @param questionClass
	 * @param questionContent
	 */
	Model.prototype.getQuestionCaption = function(questionClass, questionContent) {

		var classStr;
		if (questionClass === "SINGLE-SEL") {
			classStr = "（单选题）";
		} else if (questionClass === "MULTI-SEL") {
			classStr = "（多选题）";
		} else if (questionClass === "JUDGE") {
			classStr = "（判断题）";
		}

		return '<font color="#ff4141">' + classStr + '</font>' + questionContent;
	};

	/**
	 * 获得题目类型字符串
	 * 
	 * @param questionClass
	 */
	Model.prototype.getQuestionClassString = function(questionClass) {

		var questionClassStr;

		if (questionClass === 'SINGLE-SEL') {
			questionClassStr = "单选题";
		} else if (questionClass === 'MULTI-SEL') {
			questionClassStr = "多选题";
		} else if (questionClass === 'JUDGE') {
			questionClassStr = "判断题";
		}

		return questionClassStr;

	};

	/**
	 * 获得答案编码按钮样式
	 * 
	 * @param questionClass
	 * @param object
	 */
	Model.prototype.getAnswerCodeBtnCss = function(object) {

		var questionId = object.val("questionId");
		var questionData_row = this.comp("questionData").getRowByID(questionId);
		var questionClass = questionData_row.val("questionClass");
		var answerIds = questionData_row.val("answerIds");

		var answerId = object.val("answerId");
		var answerId_string = answerId.toString();

		var answerIds_string = "";
		// 初始可能没有值
		if (answerIds) {
			answerIds_string = answerIds.toString();
		} else {
			answerIds_string = "";
		}

		var singlesel_judge, multisel;
		var choose, notChoose;

		if (questionClass === 'SINGLE-SEL' || questionClass === 'JUDGE') {
			singlesel_judge = true;
			if (answerId_string == answerIds_string) {
				choose = true;
			} else {
				notChoose = true;
			}

		} else if (questionClass === 'MULTI-SEL') {
			multisel = true;
			if (answerIds) {
				if (answerIds_string.indexOf(answerId_string) > -1) {
					choose = true;
				} else {
					notChoose = true;
				}
			} else {
				notChoose = true;
			}
		}

		return {
			"answerCode-notChoose-SINGLESEL_JUDGE-css" : notChoose === true && singlesel_judge === true,
			"answerCode-choose-SINGLESEL_JUDGE-css" : choose === true && singlesel_judge === true,
			"answerCode-notChoose-MULTISEL-css" : notChoose === true && multisel === true,
			"answerCode-choose-MULTISEL-css" : choose === true && multisel === true
		};

	};

	/**
	 * 获得答案编码字段
	 * 
	 * @param questionClass
	 * @param object
	 */
	Model.prototype.getAnswerCode = function(object) {

		// 根据题型返回选项
		var questionId = object.val("questionId");
		var questionData_row = this.comp("questionData").getRowByID(questionId);
		var questionClass = questionData_row.val("questionClass");

		var retValue;
		var answerCode = object.val("answerCode");

		if (questionClass === 'SINGLE-SEL' || questionClass === 'MULTI-SEL') {
			retValue = answerCode;
		} else if (questionClass === 'JUDGE') {
			if (answerCode === 'true') {
				retValue = "√";
			} else if (answerCode === 'false') {
				retValue = "×";
			}
		}

		return retValue;
	};

	/**
	 * 获得答案内容
	 * 
	 * @param object
	 */
	Model.prototype.getAnswerContent = function(object) {
		var retValue;
		var answerCode = object.val("answerCode");
		var answerContent = object.val("answerContent");

		if (answerCode === 'true') {
			retValue = "正确";
		} else if (answerCode === 'false') {
			retValue = "错误";
		} else {
			retValue = answerContent;
		}

		return retValue;
	};

	/**
	 * contents 页面切换完成事件
	 * 
	 * @param event
	 */
	Model.prototype.parentContentsActiveChanged = function(event) {

		if (this._isBtnClick) {
			// 判断如果是通过上下切换按钮点击切换页面，则直接退出
			this._isBtnClick = false;
			return;
		}

		var questionData = this.comp("questionData");

		var n = "0";
		if ((event.from - event.to) > 0) {
			// 切换上一题
			questionData.pre();
			n = "-1";

		} else if (event.type == "next") {
			// 切换下一题
			questionData.next();
			n = "+1";
		}

		if (this._len > 1) {
			this.switchContent(n);
		} else {
		}

		// 给上下切换索引按钮 切换disabled Class
		this.toggleDisabledClass();

	};

	/**
	 * 上下切换题目按钮点击事件
	 * 
	 * @param evt
	 */
	Model.prototype.switchQuestionClick = function(evt) {

		var xid = evt.source.$domNode.attr("xid");

		var n = 0;

		if (xid == "prevBtn") {
			// 切换上一题
			n = "-1";

		} else if (xid == "nextBtn") {
			// 切换下一题
			n = "+1";
		}

		this.switchQuestion(n);

	};

	/**
	 * 切换题目
	 * 
	 * @param n
	 */
	Model.prototype.switchQuestion = function(n) {

		this._isBtnClick = true;
		var questionData = this.comp("questionData");
		var _contents = this.comp("parentContents");

		if (n == "-1") {
			// 切换上一题
			questionData.pre();
			_contents.prev();
		} else if (n == "+1") {
			// 切换下一题
			questionData.next();
			_contents.next();
		}

		// 切换content
		this.switchContent(n);

		// 给上下切换索引按钮 切换disabled Class
		this.toggleDisabledClass();
	};

	/**
	 * 选择答案事件
	 * 
	 * @param 传入参数
	 */
	Model.prototype.chooseAnswerClick = function(evt) {

		var self = this

		var row = evt.bindingContext.$object;
		var questionId = row.val("questionId");
		var answerId = row.val("answerId");// 当前选择的答案标识id
		var answerId_string = answerId.toString();

		var questionData = this.comp("questionData");
		var questionData_currentRow = questionData.getCurrentRow();// questionData当前行

		var questionData_answerIds = questionData_currentRow.val("answerIds");
		var questionData_questionClass = questionData_currentRow.val("questionClass");// 题型

		var _answerIds = "";// 最终答案ids集合

		if (questionData_questionClass === 'SINGLE-SEL' || questionData_questionClass === 'JUDGE') {
			// 单选和判断
			_answerIds = answerId_string;

		} else if (questionData_questionClass === 'MULTI-SEL') {
			// 多选

			if (!questionData_answerIds) {
				// 当前题目没有答案
				_answerIds = answerId_string;
			} else {
				// 判断当前选项是否被选择
				var count = questionData_answerIds.indexOf(answerId_string);

				if (count > -1) {
					// 被选择,执行在该题答案ids去除当前答案id
					if (count === 0) {
						// 当前答案id在该题目答案ids中的位置在第一位
						_answerIds = questionData_answerIds.replace(answerId_string + ",", '');
						// 特殊情况：当前答案id在该题目答案ids中的位置在第一位，并且该答案只有一个答案
						_answerIds = _answerIds.replace(answerId_string, '');
					} else {
						// 当前答案id在该题目答案ids中的位置在第二位及以后
						_answerIds = questionData_answerIds.replace("," + answerId_string, '');
					}

				} else {
					// 没有被选择,直接将当前答案id加入该题答案ids
					_answerIds = questionData_answerIds + "," + answerId_string;
				}

			}
		}

		// 记录当前已经答过的题目
		if (!questionData_answerIds) {
			// 第1种情况，该道题目第一次进行选择，直接+1
			this._answerCount++;
		} else {
			// 第2种情况，该道题目已经有了答案，单选题和判断题不进行操作
			if (!_answerIds) {
				// 第2种情况中的特殊情况，针对多选题，如果最终该题选项不存在，则在之前的题目总数中-1
				this._answerCount--;
			}
		}

		// 将最终答案set到data组件中
		questionData.setValue("answerIds", _answerIds, questionData_currentRow);
		// 同步答题卡显示data
		this.comp("sheetData").setValueByID("answerIds", _answerIds, questionData_currentRow.val("questionId"));

		// Test
		console.log("当答案标识---" + this.comp("questionData").getValueByID("answerIds", questionId));
		console.log("当前题标识---" + questionId);

	};

	/**
	 * 切换content
	 * 
	 * @param n(动作标识)
	 */
	Model.prototype.switchContent = function(n) {
		var self = this;

		var _indexI = this._indexI;// 当前题目索引下标

		var _len = this._len;// 题目数量

		// 如果传数字 2,3 之类可以使得直接滑动到该索引
		if (typeof n == 'number') {
			_indexI = _indexI;
			// 如果是传字符则为索引的变化
		} else if (typeof n == 'string') {
			_indexI = _indexI + n * 1;
		}

		if (_indexI > _len - 1) {
			// 当索引右超出
			_indexI = _len - 1;

		} else if (_indexI < 0) {
			// 当索引左超出
			_indexI = 0;
		}

		var _content = $(this.getElementByXid("parentContents")).children("div");

		// 保留当前索引值
		this._indexI = _indexI;

		if (_len == 2) {

		} else if (_len == 1) {

		} else {
			// 当题目数量>=3时
			if (n == "+1") {
				// 下一题
				if (_indexI == 1) {

				} else if (_indexI == _len - 1) {

				} else {
					// 移动节点
					self.moveDom(n, _content[0], _content[2]);
				}

			} else if (n == "-1") {
				// 上一题
				if (_indexI == _len - 2) {

				} else if (_indexI === 0) {

				} else {
					self.moveDom(n, _content[0], _content[2]);
				}

			} else if (n == "0") {
				// 不变
			}
		}

	};

	/**
	 * 根据标识n移动dom节点
	 * 
	 * @param n
	 * @param d1
	 * @param d1
	 */
	Model.prototype.moveDom = function(n, d1, d2) {

		// 移动节点
		var self = this;

		if (n == "+1") {
			insertAfter(d1, d2);
			changedata(parseInt(this._indexI + 1), d1);

		} else if (n == "-1") {
			var _contents = this.getElementByXid("parentContents");
			_contents.insertBefore(d2, d1);
			changedata(parseInt(this._indexI - 1), d2);
		}

		// 切换content关联的data数据
		function changedata(index, d) {
			var questionId = self._questionDatas[index].questionId;

			$(d).find("span.question-caption").html(self.getQuestionCaption(self._questionDatas[index].questionClass, self._questionDatas[index].questionContent));

			var listXid = $(d).find("div.x-list").attr("xid");
			var list = self.comp(listXid);
			list.set("filter", "$row.val('questionId')==" + questionId + "");
			// 刷新list
			list.refresh();
		}

		// 判断并获得当前节点的上级节点(同级)
		function get_previoussibling(n) {
			if (n.previousSibling !== null) {
				var x = n.previousSibling;
				while (x.nodeType != 1) {
					x = x.previousSibling;
				}
				return x;
			}
		}

		// 判断并获得当前节点的下级节点(同级)
		function get_nextsibling(n) {
			var x = n.nextSibling;
			if (x == null)
				return null;
			while (x && x.nodeType != 1) {
				x = x.nextSibling;
			}
			return x;
		}

		// 将一个新元素插入另一个元素后面
		function insertAfter(newElement, targetElement) {
			var parent = targetElement.parentNode;
			if (parent.lastChild == targetElement) {
				parent.insertBefore(newElement);
			} else {
				parent.insertBefore(newElement, targetElement.nextSibling);
			}
		}

	};

	/**
	 * 时间 倒计时定时器(只适用于00:00分钟倒计时)
	 * 
	 * @param testCost
	 */
	Model.prototype.countdownTimer = function(testCost) {
		var self = this;
		testCost = testCost.split(":");
		var m = parseInt(testCost[0]);
		var s = parseInt(testCost[1]);

		if (s === 0) {
			s = 60;
			m = m - 1;
		}

		if (m > -1) {
			s--;
		} else {
			return;
		}

		this._timer = setInterval(function(e) {
			var M = checkTime(m);
			var S = checkTime(s);

			function checkTime(n) {
				if (n < 10) {
					n = "0";
				} else {
					n = "";
				}
				return n;
			}

			var sM = changeTime(m);
			var sS = changeTime(s);

			function changeTime(k) {
				var retValue;
				if (k < 10 && k.length >= 2) {
					if (k == 0) {
						k = '0'
					} else {
						k = k.split("0");
						k = k[1];
					}
					retValue = k;
				} else {
					retValue = k;
				}
				return retValue;
			}

			self._testCost = M + sM + ":" + S + sS;

			self.comp("timeBtn").set({
				"label" : M + sM + ":" + S + sS
			});

			if (s === 0) {
				s = 60;
				m = m - 1;
			}

			if (m !== -1) {
				s--;
			} else {
				// 关闭计时器
				clearInterval(self._timer);
				// 添加警示颜色
				$(self.getElementByXid("timeBtn")).children("span").attr("style", "color:#ff4141");
			}

		}, 1000);

	};

	/**
	 * 暂停计时
	 * 
	 */
	Model.prototype.suspensionTiming = function() {
		var self = this;

		// 清楚当前页面的倒计时计时器
		clearInterval(this._timer);
		// 改变倒计时按钮图片为暂停
		this.comp("timeBtn").set({
			icon : "icon-ios7-pause-outline"
		});

		if (this._len !== this._answerCount) {
			// x5自带提示框
			this.comp("messageDialog1").show({
				type : "OK",
				title : "休息一下",
				message : '共' + this._len + '题,' + '还剩' + '<font color="#ff4141">' + parseInt(this._len - this._answerCount) + '</font>' + '题未做,点击确定继续答题！',
				callback : function(ret) {
					// 点击确认按钮
					if (ret.button == "ok") {
						// 开启时间倒计时
						self.countdownTimer(self._testCost);

						self.comp("timeBtn").set({
							icon : "icon-android-clock"
						});
					}
				}
			});
		} else {
			this.comp("messageDialog1").show({
				type : "OKCancel",
				title : "温馨提示",
				message : "共" + self._len + "题,您已全部做完,是否立即交卷？",
				callback : function(ret) {
					// 点击确认按钮
					if (ret.button == "ok") {
						self.theirPapers();
					} else if (ret.button == "cancel") {
						// 开启时间倒计时
						self.countdownTimer(self._testCost);
						self.comp("timeBtn").set({
							icon : "icon-android-clock"
						});
					}
				}
			});
		}

	};

	/* **************************** 答题卡 **************************** */

	/**
	 * 显示答题卡页面
	 * 
	 */
	Model.prototype.showSheetPage = function() {
		this.comp("popPicker1").show();
	};

	/**
	 * 隐藏答题卡页面
	 * 
	 */
	Model.prototype.hideSheetPage = function() {
		this.comp("popPicker1").hide();
	};

	/**
	 * 获得答题卡 题目选中/未选中按钮样式
	 * 
	 * @param object
	 * @return 返回参数
	 */
	Model.prototype.getSheetChooseBtnCss = function(object) {

		var answerIds = object.val("answerIds");

		var choose, notChoose;

		if (answerIds && answerIds !== "") {
			choose = true;
		} else {
			notChoose = true;
		}

		return {
			"sheet-notChoose-btn-css" : notChoose === true,
			"sheet-choose-btn-css" : choose === true
		};

	};

	/**
	 * 移动到指定题目
	 * 
	 * @param evt
	 */
	Model.prototype.moveToAppointTest = function(evt) {

		var self = this;

		var _content = $(this.getElementByXid("parentContents")).children("div");
		var _contents = this.comp("parentContents");
		var questionData = this.comp("questionData");

		// 获得当前行对象
		var row = evt.bindingContext.$object;

		var sheetData = this.comp("sheetData");

		var _sheet_index = sheetData.getRowIndex(row);// 当前行索引

		if (_sheet_index == this._indexI) {
			// 跳转的是当前题目，不必跳转
		} else if (_sheet_index == this._indexI + 1) {
			// 切换下一题
			this.switchQuestion("+1");
		} else if (_sheet_index == this._indexI - 1) {
			// 切换上一题
			this.switchQuestion("-1");
		} else {
			if (_sheet_index === 0) {
				// 要跳转的题目是第一题，特殊处理
				if (this._indexI == this._len - 1) {
					this._isBtnClick = true;
					_contents.to(0);
				} else {
					this._isBtnClick = true;
					_contents.prev();
				}
				changedatas(0);

			} else if (_sheet_index == this._len - 1) {
				// 要跳转的题目是最后一题，特殊处理
				if (this._indexI === 0) {
					this._isBtnClick = true;
					_contents.to(2);
				} else {
					this._isBtnClick = true;
					_contents.next();
				}

				changedatas(_sheet_index - 2);

			} else {
				// 要跳转的题目跟当前题目有2个及以上题目的跨度
				if (this._indexI === 0) {
					this._isBtnClick = true;
					_contents.next();
				} else if (this._indexI == this._len - 1) {
					this._isBtnClick = true;
					_contents.prev();
				} else {
				}
				changedatas(_sheet_index - 1);

			}

			questionData.to(this._questionDatas[_sheet_index].questionId);
			this.toggleDisabledClass();
		}

		// 重置当前索引值
		this._indexI = _sheet_index;
		// 改变页面试题数据
		function changedatas(j) {

			for (var i = 0; i < 3; i++) {
				$(_content[i]).find("span.question-caption").html(self.getQuestionCaption(self._questionDatas[j].questionClass, self._questionDatas[j].questionContent));
				var list = self.comp($(_content[i]).find("div.x-list").attr("xid"));
				list.set("filter", "$row.val('questionId')==" + self._questionDatas[j].questionId + "");
				// 刷新
				list.refresh();
				j++;
			}
		}

		// 隐藏答题卡
		this.comp("popPicker1").hide();

	};

	/**
	 * 交卷按钮点击事件
	 * 
	 */
	Model.prototype.theirPaperClick = function() {
		var self = this;
		// 有未回答的试题
		if (this._answerCount !== this._len) {

			// x5自带提示框
			this.comp("messageDialog1").show({
				type : "OKCancel",
				title : "温馨提示",
				message : '您还有' + '<font color="#ff4141">' + parseInt(self._len - self._answerCount) + '</font>' + '道题未做,确认提交吗？',
				callback : function(ret) {
					// 点击确认按钮
					if (ret.button == "ok") {
						self.theirPapers();
					}
				}
			});

			// layer提示框提示
			// layer.msg('您还有' + '<font color="#ff4141">' + parseInt(self._len -
			// self._answerCount)
			// + '</font>' + '道题未做,确认提交吗？', {
			// time : 0, // 不自动关闭
			// btn : [ '交卷', '继续答题' ],
			// yes : function(index) {
			//
			// }
			// });
		} else {
			this.comp("messageDialog1").show({
				type : "OKCancel",
				title : "温馨提示",
				message : "共" + self._len + "题,您已全部做完,是否立即交卷？",
				callback : function(ret) {
					// 点击确认按钮
					if (ret.button == "ok") {
						self.theirPapers();
					}
				}
			});
		}

	};

	/**
	 * 交卷
	 * 
	 */
	Model.prototype.theirPapers = function() {

		var self = this;

		var questionData = this.comp("questionData");

		// 提交给后台的json格式数据
		var sumbitDatas = changeDataStructure(questionData);

		// Test
		alert(JSON.stringify(sumbitDatas));

		/**
		 * 改变x5data组件数据结构为JSON格式
		 * 
		 * @param data(data组件对象)
		 * @return json
		 */
		function changeDataStructure(inData) {

			var idColumn = inData.idColumn;
			columns = (typeof (columns) == "undefined" || columns === null) ? inData.getColumnIDs() : columns;
			if (typeof (columns) == "string") {
				columns = columns.split(",");
			}
			function getRowValues(row) {
				var values = {};
				for (var i = 0; i < columns.length; i++) {
					var column = columns[i];
					var value;
					if (column == idColumn) {
						value = row.userdata.id.value;
					} else {
						value = row[column].value;
					}

					// 如果value不存在或者为空，则视为无值，置为null
					values[column] = ((typeof (value) == "undefined") || value === "") ? null : value;

				}

				return values;
			}

			var outResults = [];

			var changedData = inData.toJson();

			for (var i = 0, len = changedData.rows.length; i < len; i++) {
				var row = changedData.rows[i];
				var keyValue = row.userdata.id.changed == 1 ? row.userdata.id.originalValue : row.userdata.id.value;

				// console.log(row.userdata.recordState);

				if (row.userdata.recordState == "new") {
					outResults.push(getRowValues(row));
				} else if (row.userdata.recordState == "edit") {
					// outResults.push(getRowValues(row).concat(keyValue));
					outResults.push(getRowValues(row));
				} else if (row.userdata.recordState == "delete") {
					// 先不管删除情况
					// outResults.push([ keyValue ]);
					// outResults.push(getRowValues(row));
				} else {
					outResults.push(getRowValues(row));
				}
			}

			return outResults;

		}

	};

	/* **************************** Test **************************** */

	Model.prototype.Test = function() {
		var _content = $(this.getElementByXid("parentContents")).children("div");
		var _contents = this.getElementByXid("parentContents");

		// _contents.insertBefore(_content[2], _content[0]);// 新建的元素节点插入到
		// id为p1的元素前面

		// insertAfter(_content[0], _content[2]);

		var questiondata = this.comp("questionData");
		// alert(questiondata.getRowByID(5).val("questionContent"));

		function insertAfter(newElement, targetElement) {
			var parent = targetElement.parentNode;
			if (parent.lastChild == targetElement) {
				parent.insertBefore(newElement);
			} else {
				parent.insertBefore(newElement, targetElement.nextSibling);
			}
		}

		// this.comp("popPicker1").show();
		clearInterval(this._timer);

		this.comp("popOver1").show();

	};

	Model.prototype.button4Click = function(event) {
		var _testCost = this.comp("timeBtn").get("value");

		console.log(this._answerCount);

		// this.countdownTimer(this._testCost);

	};

	return Model;
});