define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	var Model = function() {
		this.callParent();
	};

	/**
	 * 
	 * @author shaoyi
	 * @date 2016-12-15 上午11:00:18
	 * 
	 * @email 3328175381@qq.com
	 * @copyright 作者原创，转载务必注明出处，谢谢！
	 * 
	 * @project 英雄三国APP
	 * @description 考试列表页面
	 * 
	 */

	/**
	 * 跳转到考试页面
	 * 
	 * @param event
	 */
	Model.prototype.button1Click = function(event) {

		var self = this;

		$.ajax({
			type : "GET",
			url : require.toUrl('./test.json'),
			dataType : 'json',
			async : false,// 使用同步方式，目前data组件有同步依赖
			cache : false,
			success : function(data) {

				// 添加索引值
				$.each(data.examQuestion.rows, function(i, item) {
					item.testIndex = i;
				});
				
				
				//排序
				function sorting(datas) {

					var examQuestion = datas.examQuestion;
					var examQuestionAnswer = datas.examQuestionAnswer;

					var examQuestion_rows = examQuestion.rows;
					var examQuestionAnswer_rows = examQuestionAnswer.rows;

					var letter = [ "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "true", "false" ];

					// 主键标识排序(试题顺序)
					examQuestion_rows.sort(function(a, b) {
						return a.seqNo - b.seqNo;
					});

					// 字母排序
					examQuestionAnswer_rows.sort(function(a, b) {
						var sA, sB;
						$.each(letter, function(i, item) {
							if (a.answerCode === item) {
								sA = i;
							}
							if (b.answerCode === item) {
								sB = i;
							}
						});
						return sA - sB;
					});

					datas.examQuestion.rows = examQuestion_rows;
					datas.examQuestionAnswer.rows = examQuestionAnswer_rows;

				}
				sorting(data);

				self.Test(data);
			},
			error : function() {
				alert("加载数据失败");
			}
		});

	};

	/**
	 * 测试
	 * 
	 * @param testPaperDatas
	 */
	Model.prototype.Test = function(testPaperDatas) {

		var params = {
			"testStaffId" : 1,
			"testId" : "考试标识",
			"staffId" : "人员标识",
			"staffTestState" : "10I",
			"staffTestStateName" : "未参加",
			"testName" : "基础考试",
			"testBeginTime" : "开始时间",
			"testEndTime" : "2016-05-23 10:44:00",
			"testScore" : "100",
			"testCost" : "5",
			"testQuestionCount" : "6",
			"passScore" : "70",
			"singelSelCount" : "2",
			"singelSelTotalScore" : "30",
			"judgeCount" : "1",
			"judgeTotalScore" : "40",
			"multiSelCount" : "3",
			"multiSelTotalScore" : "30",
			"testPaperDatas" : testPaperDatas
		};

		var url = require.toUrl("./test.w");
		// 跳转到考试页面
		this.comp("windowDialog1").open({
			src : url,
			data : params
		});
	};

	return Model;
});